//+------------------------------------------------------------------+
//|                                                 pivot points.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DimGray
#property indicator_color2 SteelBlue
#property indicator_color3 RosyBrown
#property indicator_color4 SteelBlue
#property indicator_color5 RosyBrown
#property indicator_color6 SteelBlue
#property indicator_color7 RosyBrown
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

//
//
//
//
//

 extern string PivotIdentifier       = "pivot1";
 extern string TimeFrame             = "D1";
 extern int    HourShift             = 0;
 extern bool   FixSundays            = true;
 extern bool   HideConnections       = false;
 extern bool   ShowLabels            = true;
 extern bool   ShowPrices            = false;
 extern color  LabelsColor           = DimGray;
 extern int    LabelsFontSize        =  10;
 extern int    LabelsShiftHorizontal =  10;
 extern int    LabelsShiftVertical   =   1;
 extern bool   RightAlign            = false;
 extern int    LinesShiftRight       =  10;
 extern color  LinesPivotColor       = DimGray;
 extern color  LinesSupportColor     = SteelBlue;
 extern color  LinesResistanceColor  = RosyBrown;
 extern int    LinesPivotStyle       = STYLE_DOT;
 extern int    LinesSupportStyle     = STYLE_DOT;
 extern int    LinesResistanceStyle  = STYLE_DOT;
 extern int    LinesSupportWidth     = 0;
 extern int    LinesPivotWidth       = 0;
 extern int    LinesResistanceWidth  = 0;

//
//
//
//
//

double PBuffer[];
double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
double S3Buffer[];
double R3Buffer[];

//
//
//
//
//

string labels[7] = {"P" ,"S1","R1","S2","R2","S3","R3"};
int    timeFrame;
int    lookupTimeFrame;
string Description;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   lookupTimeFrame = PERIOD_H1;
   timeFrame       = stringToTimeFrame(TimeFrame);
            if (timeFrame<PERIOD_D1)
            {
               HourShift=0;
               lookupTimeFrame = timeFrame;
            }         
            if (timeFrame==PERIOD_W1)
            {
               if (HourShift<0) HourShift -= 24;
               if (HourShift>0) HourShift += 24;
            }
   
   //
   //
   //
   //
   //
   
      SetIndexBuffer(0,PBuffer);  SetIndexLabel(0,Description+labels[0]);
      SetIndexBuffer(1,S1Buffer); SetIndexLabel(1,Description+labels[1]);
      SetIndexBuffer(2,R1Buffer); SetIndexLabel(2,Description+labels[2]);
      SetIndexBuffer(3,S2Buffer); SetIndexLabel(3,Description+labels[3]);
      SetIndexBuffer(4,R2Buffer); SetIndexLabel(4,Description+labels[4]);
      SetIndexBuffer(5,S3Buffer); SetIndexLabel(5,Description+labels[5]);
      SetIndexBuffer(6,R3Buffer); SetIndexLabel(6,Description+labels[6]);
      for (int i=0; i<8; i++)
         if (RightAlign)
               SetIndexStyle(i,DRAW_NONE);
         else  SetIndexStyle(i,DRAW_LINE);
   return(0);
}

int deinit()
{
   string lookFor       = PivotIdentifier+":";
   int    lookForLength = StringLen(lookFor);   
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,lookForLength) == lookFor) ObjectDelete(name);
   }         
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if (Period() >= timeFrame) return(-1);
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
      limit = MathMin(MathMax(Bars-counted_bars,2*timeFrame/_Period),Bars-1);

   //
   //
   //
   //
   //

   double P =  PBuffer[limit+1];
   double S1 = S1Buffer[limit+1];
   double R1 = R1Buffer[limit+1];
   double S2 = S2Buffer[limit+1];
   double R2 = R2Buffer[limit+1];
   double S3 = S3Buffer[limit+1];
   double R3 = R3Buffer[limit+1];
   
   for (i=limit; i>=0; i--)
   {
      int x = iBarShift(NULL,timeFrame,Time[i+1]-HourShift*3600,true);
      int y = iBarShift(NULL,timeFrame,Time[i]  -HourShift*3600,true);
      if (x!=y)
      {
         int k = i;
         if (FixSundays && timeFrame==PERIOD_D1)
         {
            while (k<Bars && TimeDayOfWeek(Time[k+1]-HourShift*3600)==0) k++;
         }
         int z = iBarShift(NULL,lookupTimeFrame,Time[k+1]-timeFrame*60-HourShift*3600);
             x = iBarShift(NULL,lookupTimeFrame,Time[k+1]             -HourShift*3600);
               
             //
             //
             //
             //
             //

             double LastHigh  = iHigh (NULL,lookupTimeFrame,iHighest(NULL,lookupTimeFrame,MODE_HIGH,z-x,x));
             double LastLow   = iLow  (NULL,lookupTimeFrame,iLowest( NULL,lookupTimeFrame,MODE_LOW ,z-x,x));
             double LastClose = Close[k+1];
               
             //
             //
             //
             //
             //
               
             P  = (LastHigh+LastLow+LastClose)/3;
             R1 = (2*P)-LastLow;
             S1 = (2*P)-LastHigh;
             R2 = P+(LastHigh - LastLow);
             S2 = P-(LastHigh - LastLow);
             R3 = (2*P)+(LastHigh-(2*LastLow));
             S3 = (2*P)-((2* LastHigh)-LastLow); 
      }
                  
      //
      //
      //
      //
      //
        
      PBuffer[i] =P;
      S1Buffer[i]=S1;
      R1Buffer[i]=R1;
      S2Buffer[i]=S2;
      R2Buffer[i]=R2;
      S3Buffer[i]=S3;
      R3Buffer[i]=R3;
   }
   if (RightAlign) 
   {
      createLine("0",P ,LinesPivotColor     ,LinesPivotStyle     ,LinesPivotWidth);
      createLine("1",S1,LinesSupportColor   ,LinesSupportStyle   ,LinesSupportWidth);
      createLine("2",S2,LinesSupportColor   ,LinesSupportStyle   ,LinesSupportWidth);
      createLine("3",S3,LinesSupportColor   ,LinesSupportStyle   ,LinesSupportWidth);
      createLine("4",R1,LinesResistanceColor,LinesResistanceStyle,LinesResistanceWidth);
      createLine("5",R2,LinesResistanceColor,LinesResistanceStyle,LinesResistanceWidth);
      createLine("6",R3,LinesResistanceColor,LinesResistanceStyle,LinesResistanceWidth);
   }      
   else if (HideConnections) DoHideConnections(limit);
        if (ShowLabels || ShowPrices) DisplayLabels();
   return(0);
}



//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void DisplayLabels()
{
   ShowLabel(1,PBuffer ,Description+labels[0]);
   ShowLabel(2,S1Buffer,Description+labels[1]);
   ShowLabel(3,R1Buffer,Description+labels[2]);
   ShowLabel(4,S2Buffer,Description+labels[3]);
   ShowLabel(5,R2Buffer,Description+labels[4]);
   ShowLabel(6,S3Buffer,Description+labels[5]);
   ShowLabel(7,R3Buffer,Description+labels[6]);
}
void ShowLabel(string ID, double& forLine[],string label)
{
   string finalLabel = "";
   
   if (ShowLabels) finalLabel = label;
   if (ShowPrices) finalLabel = finalLabel+" "+DoubleToStr(forLine[0],Digits);
         SetLabel(ID,forLine[0],finalLabel);
}

//
//
//
//
//

void SetLabel(string ID,double forLine,string label)
{
   datetime theTime = Time[0]+LabelsShiftHorizontal*Period()*60;
   string   name    = PivotIdentifier+":"+ID;
   
   ObjectCreate(name,OBJ_TEXT,0,0,0);
   ObjectSetText(name,label,LabelsFontSize,"Arial Bold",LabelsColor);
      ObjectMove(name,0,theTime,forLine+LabelsShiftVertical*Point);
   
}

//
//
//
//
//

void createLine(string name, double price, color theColor, int style=STYLE_SOLID, int width=1)
{
   name = PivotIdentifier+":l:"+name;
   ObjectCreate(name,OBJ_TREND,0,Time[0]+Period()*LinesShiftRight*60,price,Time[0]+(LinesShiftRight+1)*60,price);
         ObjectSet(name,OBJPROP_TIME1,Time[0]+Period()*LinesShiftRight*60);
         ObjectSet(name,OBJPROP_TIME2,Time[0]+Period()*(LinesShiftRight+1)*60);
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSet(name,OBJPROP_PRICE2,price);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,style);
         ObjectSet(name,OBJPROP_WIDTH,width);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void DoHideConnections(int limit)
{
   
   for (int i=limit;i>=0;i--)
   {
      if (PBuffer[i]  != PBuffer[i+1])  HideIt(i,PBuffer);
      if (R1Buffer[i] != R1Buffer[i+1]) HideIt(i,R1Buffer);
      if (S1Buffer[i] != S1Buffer[i+1]) HideIt(i,S1Buffer);
      if (R2Buffer[i] != R2Buffer[i+1]) HideIt(i,R2Buffer);
      if (S2Buffer[i] != S2Buffer[i+1]) HideIt(i,S2Buffer);
      if (R3Buffer[i] != R3Buffer[i+1]) HideIt(i,R3Buffer);
      if (S3Buffer[i] != S3Buffer[i+1]) HideIt(i,S3Buffer);
   }
}

void HideIt(int i, double& from[])
{
   if ((from[i] != EMPTY_VALUE) && (from[i+1] != EMPTY_VALUE))
        from[i+1] = EMPTY_VALUE;  
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       StringToUpper(tfs);
         if (tfs=="M1" || tfs=="1")     { tf=PERIOD_M1;  Description = "";}
         if (tfs=="M5" || tfs=="5")     { tf=PERIOD_M5;  Description = "M5 "; }
         if (tfs=="M15"|| tfs=="15")    { tf=PERIOD_M15; Description = "M15 ";}
         if (tfs=="M30"|| tfs=="30")    { tf=PERIOD_M30; Description = "M30 "; }
         if (tfs=="H1" || tfs=="60")    { tf=PERIOD_H1;  Description = "X ";    }
         if (tfs=="H4" || tfs=="240")   { tf=PERIOD_H4;  Description = "16";  }
         if (tfs=="D1" || tfs=="1440")  { tf=PERIOD_D1;  Description = "D ";     }
         if (tfs=="W1" || tfs=="10080") { tf=PERIOD_W1;  Description = "W";    }
         if (tfs=="MN" || tfs=="43200") { tf=PERIOD_MN1; Description = "M";   }
  return(tf);
}
